HDU 1069

A group of researchers are designing an experiment to test the IQ of a monkey. They will hang a banana at the roof of a building, and at the mean time, provide the monkey with some blocks. If the monkey is clever enough, it shall be able to reach the banana by placing one block on the top another to build a tower and climb up to get its favorite food. 

The researchers have n types of blocks, and an unlimited supply of blocks of each type. Each type-i block was a rectangular solid with linear dimensions (xi, yi, zi). A block could be reoriented so that any two of its three dimensions determined the dimensions of the base and the other dimension was the height. 

They want to make sure that the tallest tower possible by stacking blocks can reach the roof. The problem is that, in building a tower, one block could only be placed on top of another block as long as the two base dimensions of the upper block were both strictly smaller than the corresponding base dimensions of the lower block because there has to be some space for the monkey to step on. This meant, for example, that blocks oriented to have equal-sized bases couldn't be stacked. 

Your job is to write a program that determines the height of the tallest tower the monkey can build with a given set of blocks. 
InputThe input file will contain one or more test cases. The first line of each test case contains an integer n, 
representing the number of different blocks in the following data set. The maximum value for n is 30. 
Each of the next n lines contains three integers representing the values xi, yi and zi. 
Input is terminated by a value of zero (0) for n. 
OutputFor each test case, print one line containing the case number (they are numbered sequentially starting from 1) and the height of the tallest possible tower in the format "Case case: maximum height = height". 
Sample Input
1
10 20 30
2
6 8 10
5 5 5
7
1 1 1
2 2 2
3 3 3
4 4 4
5 5 5
6 6 6
7 7 7
5
31 41 59
26 53 58
97 93 23
84 62 64
33 83 27
0
Sample Output
Case 1: maximum height = 40
Case 2: maximum height = 21
Case 3: maximum height = 28
Case 4: maximum height = 342


一个比较简单的题,大意是,给你一些类型的方块,每种类型方块数量无限,问这些方块最高能垒多高。要求是下面方块的长和宽要大于上面的(不是大于等于)

题解:可以把每种类型的方块看成六个不同的方块,因为垒的方法不同,长宽高就不同,然后dp[i]表示,以i为基础,可以垒多高,如果事先按长宽从小到大排序,则两个for循环就能求出结果,如果不排序,则要再在外面加一层for循环,但是我只是隐隐约约明白要加,至于为什么我也不太能用语言说出来,不过由于n最大为30,三层for循环是不会超时的,不过用时会比先排序长的多

代码:

#include<stdio.h>
#include<iostream>
#include<algorithm>
#include<string.h>
using namespace std;
struct R{
	int x,y,z;
	int dp;
};
R dp[500];
int cnt;
int cmp(R a,R b){
	if(a.x!=b.x) return a.x<b.x;
	else return a.y<b.y;
}
void add(int x,int y,int c){
	dp[cnt].x=x;
	dp[cnt].y=y;
	dp[cnt].z=c;
	dp[cnt].dp=c;
	cnt++;
}

int main(){
	int n,tt=1;
	while(scanf("%d",&n)&&n){
		cnt=0;
		for(int i=0;i<n;i++){
			int a,b,c;
			scanf("%d%d%d",&a,&b,&c);
			add(a,b,c);
			add(a,c,b);
			add(b,a,c);
			add(b,c,a);
			add(c,a,b);
			add(c,b,a);
		}
		sort(dp,dp+cnt,cmp);
		for(int i=0;i<cnt;i++){
			for(int k=0;k<cnt;k++){
				if(dp[i].x>dp[k].x&&dp[i].y>dp[k].y){
					dp[i].dp=max(dp[i].dp,dp[k].dp+dp[i].z);
				}
			}
		}	
		int Max=0;
		for(int i=0;i<cnt;i++) if(Max<dp[i].dp) Max=dp[i].dp;
		printf("Case %d: maximum height = %d\n",tt++,Max);
	}
}

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 1
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论 1
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值